#include "MeshLoader.h"


MeshLoader::MeshLoader() //!!! Зачем нужен пустой конструктор. Используйте = defualt при необходимости.
{
}


MeshLoader::~MeshLoader() //!!! Зачем нужен пустой деструктор
{
}

std::vector<Node>& MeshLoader::getNodes()
{
	return Nodes;
}

std::vector<FiniteElement>& MeshLoader::getFiniteElements()
{
	return FiniteElements;
}

std::vector<BoundaryFiniteElement>& MeshLoader::getBoundaryFiniteElements()
{
	return BoundaryFiniteElements;
}

std::vector<FiniteElement&> MeshLoader::findElem(int id_1, int id_2) //!!! Вектор из ссылок НЕ КОМПИЛИРУЕТСЯ
{
	std::vector<FiniteElement&> result;
	auto   last = FiniteElements.begin();
	while (last != FiniteElements.end())
	{
		last = find_if(last, FiniteElements.end(), [id_1, id_2](FiniteElement& elem)
			{
				return (std::find(elem.nodesId.begin(), elem.nodesId.end(), id_1) != elem.nodesId.end()
					&& std::find(elem.nodesId.begin(), elem.nodesId.end(), id_2) != elem.nodesId.end());
			});

		if (last != FiniteElements.end())
			result.push_back(*last++);
	}

	return result;
}

std::vector<FiniteElement&> MeshLoader::findElem(int id_1, int id_2, int id_3) //!!! Вектор из ссылок НЕ КОМПИЛИРУЕТСЯ
{
	std::vector<FiniteElement&> result;
	auto   last = FiniteElements.begin();
	while (last != FiniteElements.end())
	{
		last = find_if(last, FiniteElements.end(), [id_1, id_2, id_3](FiniteElement& elem) //!!! elem не изменяется. Нужен const
			{
				return (std::find(elem.nodesId.begin(), elem.nodesId.end(), id_1) != elem.nodesId.end()
					&& std::find(elem.nodesId.begin(), elem.nodesId.end(), id_2) != elem.nodesId.end()
					&& std::find(elem.nodesId.begin(), elem.nodesId.end(), id_3) != elem.nodesId.end());
			});

		if (last != FiniteElements.end())
			result.push_back(*last++);
	}

	return result;
}

std::vector<unsigned int>& MeshLoader::getNodesByBoundaryFiniteElementID(int id)
{

	/*
		return find_if(BoundaryFiniteElements.begin(), BoundaryFiniteElements.end(), [id](BoundaryFiniteElements& elem)
			{
				return (std::find(elem.nodes.begin(), elem.nodes.end(), id) != elem.nodes.end()
			});
		for (auto& s : BoundaryFiniteElements)
			if (s.m_id == id)
				for (auto& n : s.nodes_id)
					resContainer.push_back(n);
		return resContainer;*/
}



std::ostream& operator<<(std::ostream& stream, MeshLoader& mesh)
{
	stream << "Nodes:\n";
	for (auto& i : mesh.getNodes())
		stream << i;

	stream << "\nFiniteElements:\n";
	for (auto& i : mesh.getFiniteElements())
		stream << i;

	stream << "\nBoundaryFiniteElements:\n";
	for (auto& i : mesh.getBoundaryFiniteElements())
		stream << i;

	return stream;
}

